ad_page_contract {
    Manage workflow task panels.

    @author Lars Pind (lars@pinds.com)
    @creation-date December 15, 2000
    @cvs-id $Id: attributes.tcl,v 1.1 2001/03/13 22:59:27 ben Exp $
} {
    workflow_key
} -validate {
    workflow_exists -requires {workflow_key} {
	if ![db_string workflow_exists "
	select 1 from wf_workflows 
	where workflow_key = :workflow_key"] {
	    ad_complain "You seem to have specified a nonexistent workflow."
	}
    }
} -properties {
    workflow_key
    context_bar
    attributes:multirow
    add_url
}

db_1row workflow_name {
    select ot.pretty_name as workflow_name
    from   acs_object_types ot
    where  ot.object_type = :workflow_key
}

set context_bar [ad_context_bar [list "workflow?[export_url_vars workflow_key]" "$workflow_name"] "Attributes"]

db_multirow attributes attributes {
    select a.attribute_id,
           a.sort_order,
           a.attribute_name,
           a.pretty_name,
           a.datatype,
           '' as delete_url,
           (select count(*) from wf_transition_attribute_map m
            where  m.workflow_key = a.object_type
            and    m.attribute_id = a.attribute_id) as used_p
    from   acs_attributes a
    where  a.object_type = :workflow_key
    order by sort_order
} {
    set delete_url "attribute-delete?[export_vars -url {workflow_key attribute_id}]"
}

set add_url "attribute-add?[export_vars -url {workflow_key}]"

ad_return_template



