ad_page_contract {
    Add task.
} {
    workflow_key:notnull
    transition_name:notnull
    trigger_type:notnull
    estimated_minutes:optional,integer
    {context_key "default"}
} -validate {
    transition_name_unique -requires { workflow_key:notnull transition_name:notnull } {
	set num_rows [db_string num_transitions {
	    select count(*) 
	    from   wf_transitions
	    where  workflow_key = :workflow_key
	    and    transition_name = :transition_name
	}]

        if { $num_rows > 0 } {
	    ad_complain "There is already a task with this name"
	}
    }

    trigger_type_legal -requires { trigger_type } {
	set trigger_type [string tolower $trigger_type]
	if { [lsearch -exact { user automatic message time } $trigger_type] == -1 } {
	    ad_complain "Trigger type must be one of user, automatic, message or time."
	}
    }
}


set transition_key [wf_make_unique -maxlen 100 \
	-taken_names [db_list transition_keys {select transition_key from wf_transitions where workflow_key = :workflow_key}] \
	[wf_name_to_key $transition_name]]

db_transaction {
    
    db_dml transition_add {
	insert into wf_transitions (transition_key, transition_name, workflow_key, trigger_type)
	values (:transition_key, :transition_name, :workflow_key, :trigger_type)
    }

    if { [info exists estimated_minutes] && ![empty_string_p $estimated_minutes] } {
	db_dml estimated_minutes {
	    insert into wf_context_transition_info 
	    (context_key, workflow_key, transition_key, estimated_minutes)
	    values (:context_key, :workflow_key, :transition_key, :estimated_minutes)
	}
    }
}
    
wf_workflow_changed $workflow_key

ad_returnredirect "define?[export_url_vars workflow_key transition_key]"



