ad_page_contract {
    Add assignee
} {
    task_id:integer
    return_url:optional
} -properties {
    context_bar
    export_vars
    party_widget
}

array set task [wf_task_info $task_id]

# if the user is assigned, they can always view the task.
# if they aren't assigned and there is an access_privilege, we check it
if { ! $task(this_user_is_assigned_p) && ![empty_string_p $task(access_privilege)]} {
    ad_require_permission $task(object_id) $task(access_privilege) 
}

set context_bar [ad_context_bar [list "case?case_idf=$task(case_id)" "Case \"$task(object_name)\""] [list "task?[export_url_vars task_id]" "Task \"$task(task_name)\""] "Add assignee"]

set export_vars [export_form_vars task_id return_url]

set party_widget "<select name=\"party_id\">\n"

db_foreach unassigned_parties {
    select p.party_id,
           acs_object.name(p.party_id) as name,
           p.email
    from   parties p
    where  not exists (select 1 from wf_task_assignments ta where ta.task_id = :task_id and ta.party_id = p.party_id)
} {
    append party_widget "<option value=\"$party_id\">$name [ad_decode $email "" "" "(<a href=\"mailto:$email\">$email</a>)"]</option>\n"
}
append party_widget "</select>"

ad_return_template

