ad_page_contract {
    Remove one or more assignees for a task.
} {
    task_id:integer
    {return_url "task?[export_url_vars task_id]"}
} -properties {
    context_bar
    task:onerow
    assignees:multirow
    effective_assignees:multirow
    done_export_vars
}

array set task [wf_task_info $task_id]

# if the user is assigned, they can always view the task.
# if they aren't assigned and there is an access_privilege, we check it
if { ! $task(this_user_is_assigned_p) && ![empty_string_p $task(access_privilege)]} {
    ad_require_permission $task(object_id) $task(access_privilege) 
}


set party_id [ad_conn user_id]
set orig_return_url $return_url
set return_url "task-assignees?[export_url_vars task_id return_url]"
set task(add_assignee_url) "assignee-add?[export_url_vars task_id return_url]"
set task(assign_yourself_url) "assignee-add-2?[export_url_vars task_id party_id return_url]"


set context_bar [ad_context_bar [list "case?case_id=$task(case_id)" "$task(object_name) case"] [list "task?[export_url_vars task_id]" "$task(task_name)"] "Assignees"]

db_multirow assignees assignees {
    select p.party_id,
           acs_object.name(p.party_id) as name,
           p.email,
           '' as remove_url
    from   wf_task_assignments ta,
           parties p
    where  ta.task_id = :task_id
    and    p.party_id = ta.party_id
} {
    set remove_url "assignee-remove-2?[export_url_vars task_id party_id return_url]"
}

db_multirow effective_assignees effective_assignees {
    select distinct u.user_id,
           acs_object.name(u.user_id) as name,
           p.email
    from   wf_task_assignments ta,
           party_approved_member_map m,
           parties p,
           users u
    where  ta.task_id = :task_id
    and    m.party_id = ta.party_id
    and    p.party_id = m.member_id
    and    u.user_id = p.party_id
}

set return_url $orig_return_url
set done_export_vars [export_form_vars task_id return_url]

ad_return_template

