ad_page_contract {
    Presents confirmation screen for deleting a forum.

    @author Anukul Kapoor (akk@arsdigita.com)
    @creation-date 2000-30-11
    @cvs-id $Id: forum-delete-2.tcl,v 1.1 2001/04/20 20:51:09 donb Exp $
} {
    forum_id:integer,notnull,bboard_forum_id
} -properties {
    forum_id:onevalue
    short_name:onevalue
    charter:onevalue
}

set user_id [ad_verify_and_get_user_id]

ad_require_permission $forum_id bboard_delete_forum

db_transaction {
    db_dml messages_delete {
	declare
	    cursor message_cursor is
	        select distinct m.message_id
                    from acs_messages m, bboard_forum_message_map f
                    where m.message_id = f.message_id
                          and f.forum_id = :forum_id;
        begin
	    for message_val in message_cursor loop
                acs_message.delete(message_val.message_id);
            end loop;
        end;
    }

    db_dml categories_delete {
	declare
	    cursor category_cursor is
	        select distinct category_id
                    from bboard_categories c
                    where c.forum_id = :forum_id;
        begin
	    for category_val in category_cursor loop
                bboard_category.delete(category_val.category_id);
            end loop;
        end;
    }

    db_dml forum_delete {
	begin
	    bboard_forum.delete (:forum_id);
	end;
    }
}
ad_returnredirect ""
