ad_page_contract {
    Scan the MP3StagingLocation directory for new files
} {
}

set user_id [ad_verify_and_get_user_id]
set package_id [ad_conn package_id]
set creation_ip [ad_conn "peeraddr"]
set creation_user [ad_conn "user_id"]

set file_list [get_list_of_mp3s]


foreach file_name $file_list {
    if {![regexp {(([^/]*)\.[mM][Pp]3)$} $file_name match client_filename mp3_name] } {
	append page_html "Broke on $file_name<br>\n"
	continue
    }

    if [db_0or1row check_file_name "
        select deleted_p 
        from   mp3_mp3s
        where  file_path = :client_filename"] {
	if { $deleted_p == "f" } {
	    append page_html "$file_name is already in the db. Continuing.<br>\n"
	    continue
	} else {
	    set update_entry_p 1
	}
    } else {
	set update_entry_p 0
    }
#     if {[db_string mp3_exists "select count(*) from mp3_mp3s where file_path = :client_filename"] != 0} {
# 	append page_html "$file_name is already in the db. Continuing.<br>"
# 	continue
#     }

    set target_filename "[ad_parameter MP3FileLocation]/$client_filename"
    file copy -force $file_name $target_filename

    set file_info [exec "[acs_root_dir]/packages/mp3jukebox/bin/mp3_file_scan" $target_filename]

    set file_ct 0
    set plsql_arguments ""
    set plsql_arguments_list [list]

    set file_info_vars [ns_set create]

    foreach info_pair $file_info {
	set key [string tolower [lindex $info_pair 0]]
	set value [lindex $info_pair 1]

	# Munge the ID3 formats into our column names
	# This totally sucks, but you've gotta do it
	# somewhere... : (.
#	regsub {title$} $key "mp3_title" key
	regsub {comment$} $key "comments" key
	regsub {mm$} $key "minutes" key
	regsub {ss$} $key "seconds" key
	if { [regsub {copyright$} $key "copyright_p" key]} {
	    	    if {$value == 1} {
		set value t
	    } else {
		set value f
	    }
	}


	if { [regsub {stereo$} $key "stereo_p" key] } {
	    if {$value == 1} {
		set value t
	    } else {
		set value f
	    }
	}

	if { [regsub {vbr$} $key "vbr_p" key] } {
	    if {$value == 1} {
		set value t
	    } else {
		set value f
	    }
	}

	regsub {mode$} $key "mode_num" key
#	regsub {file$} $key "file_path" key

#	ns_set put $file_info_vars $key $value
 	set $key $value

# 	lappend plsql_arguments_list "$key => :$key"

	set "info_pairs($key)" ":$key"
    }
    
    # Is there a title defined?
    if { ![llength [array get info_pairs title]] } {
       set info_pairs(title) ":mp3_name"
     }

    if $update_entry_p {
	set mp3_id [db_string get_mp3_id "
select mp3_id 
from   mp3_mp3s 
where  file_path = :client_filename"]

	set sql "
update mp3_mp3s
set    deleted_p = 'f'
"

	foreach i_key [array names info_pairs] {
	    append sql ",\n       $i_key = $info_pairs($i_key)"
	}
	append sql "
where  mp3_id = :mp3_id
"

	set sql2 "
update acs_objects
set    creation_user = :creation_user,
       creation_ip = :creation_ip,
       creation_date = sysdate,
       context_id = :package_id
where object_id = :mp3_id
"


	if [catch { 
	    db_transaction {
		db_dml undelete_mp3 $sql
		db_dml fix_creation $sql2
	    }
	} errmsg ] {

	    set complaint " The database did not accept your input. 
	See details for the error message below\n\n\t<p><b>$errmsg</b>"
	    ad_return_error "Database Error" "$complaint" 
	    return -code return
	
	} 

    } else {
	set sql "
begin
   :1 := mp3.new(
      file_path => :client_filename,"

	foreach i_key [array names info_pairs] {
	    append sql "\n      $i_key => $info_pairs($i_key),"
	}
	append sql "
      creation_user => :creation_user,
      creation_ip => :creation_ip,
      creation_date => sysdate,
      context_id => :package_id
);
end;
"

	if [catch { 
	    db_exec_plsql add_mp3 $sql
	} errmsg ] {

	    set complaint " The database did not accept your input. 
	See details for the error message below\n\n\t<p><b>$errmsg</b>"
	    ad_return_error "Database Error" "$complaint" 
	    return -code return
	}
    }

    unset info_pairs
    
    append page_html "<p><b>Completed $file_name.</b><p>\n"

}

# Stuck all this here so that title wouldn't collide in the namespace

set staging_location [ad_parameter MP3StagingLocation]
set page_title "Scanning MP3 Staging Location"
set title $page_title
set context_bar [list $title]
